
// BillAcceptorDlg.cpp : implementation file
//------------------------------------------
#include "stdafx.h"
#include "BillAcceptor.h"
#include "BillAcceptorDlg.h"
#include "MDBEngine.h"
#include "BillInfo.h"
#include "BillEnable.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CBillAcceptorDlg dialog
//------------------------

CBillAcceptorDlg::CBillAcceptorDlg(CWnd* pParent) : CDialog(CBillAcceptorDlg::IDD, pParent)
//=========================================================================================
{
	//{{AFX_DATA_INIT(CBillAcceptorDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBillAcceptorDlg::DoDataExchange(CDataExchange* pDX)
//=======================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBillAcceptorDlg)
	DDX_Control(pDX, IDC_AMOUNT, m_Amount);
	DDX_Control(pDX, IDC_LASTSTATUS, m_LastStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBillAcceptorDlg, CDialog)
	//{{AFX_MSG_MAP(CBillAcceptorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_COMMAND(IDM_ABOUT, OnAbout)
	ON_COMMAND(IDM_BILLINFO, OnBillinfo)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_COMMAND(IDM_BILLENABLE, OnBillenable)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_BN_CLICKED(IDC_DISABLE, OnDisable)
	ON_BN_CLICKED(IDC_ESCROW, OnEscrow)
	ON_BN_CLICKED(IDC_ACCEPT, OnAccept)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_BILL_STATUS,CBillAcceptorDlg::OnBillStatus)
END_MESSAGE_MAP()

// CBillAcceptorDlg message handlers
//----------------------------------

BOOL CBillAcceptorDlg::OnInitDialog()
//===================================
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	//--------------------------------------------------
	ASSERT((IDM_ABOUTBOX&0xFFF0)==IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX<0xF000);
	CMenu* pSysMenu=GetSystemMenu(FALSE);
	if (pSysMenu!=NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING,IDM_ABOUTBOX,strAboutMenu);
		}
	}

	// Set the icon for this dialog. The framework does this automatically
	// when the application's main window is not a dialog.
	//--------------------------------------------------------------------
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE); // Set small icon

	// Initialize the bill acceptor
	//-----------------------------
	SLAVE_SETUP Setup; // I am executive master
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
	Setup.dwDevice=0;
	Setup.dwTimeout=10;
	Setup.dwInterval=100;
	Setup.dwMaxRetry=10;
	Setup.dwMaxFail=10;
	if (!BillCreate(&Setup))
	{
		TRACE(_T("Failed to create VMC\r\n"));
	}

	// Reset main dialog
	//------------------
	memset(&m_BillInfo,0,sizeof(BILL_INFO));
	return TRUE;
}

void CBillAcceptorDlg::OnSysCommand(UINT nID, LPARAM lParam)
//==========================================================
{
	if ((nID&0xFFF0)==IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID,lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CBillAcceptorDlg::OnPaint() 
//==============================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND,(WPARAM)dc.GetSafeHdc(),0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
//---------------------------------------------------------------------------

HCURSOR CBillAcceptorDlg::OnQueryDragIcon()
//=========================================
{
	return (HCURSOR) m_hIcon;
}

void CBillAcceptorDlg::OnDestroy() 
//================================
{
	CDialog::OnDestroy();
	if (!BillDestroy())
	{
		TRACE(_T("Failed to destroy bill acceptor\r\n"));
	}
}

void CBillAcceptorDlg::OnAbout() 
//==============================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

void CBillAcceptorDlg::OnBillinfo() 
//=================================
{
	CBillInfo BillInfo;
	BillInfo.DoModal();
}

void CBillAcceptorDlg::OnReset() 
//==============================
{
	BillReset();	
}

void CBillAcceptorDlg::OnBillenable() 
//===================================
{
	CBillEnable BillEnable;
	BillEnable.DoModal();
}

void CBillAcceptorDlg::OnEnable() 
//===============================
{
	CWinApp* pApp=AfxGetApp();
	BillEnable(pApp->GetProfileInt(_T("Current"),_T("Enable"),0),
		pApp->GetProfileInt(_T("Current"),_T("Escrow"),0));
	m_LastStatus.SetWindowText(_T("Unit enabled."));
}

void CBillAcceptorDlg::OnDisable() 
//================================
{
	BillEnable(0,0);	
	m_LastStatus.SetWindowText(_T("Unit disabled."));
}

void CBillAcceptorDlg::OnEscrow() 
//===============================
{
	BillEscrow(false);		
}

void CBillAcceptorDlg::OnAccept()
//=============================== 
{
	BillEscrow(true);	
}

void CBillAcceptorDlg::DisplayAmount(DWORD dwValue)
//=================================================
{
	CString sValue;
	switch (m_BillInfo.dwDecimalPlaces)
	{
		case 0:
		{
			sValue.Format(_T("%d"),dwValue);
			break;
		}
		case 1:
		{
			sValue.Format(_T("%2.1d"),((double)dwValue)/10);
			break;
		}
		case 2:
		{
			sValue.Format(_T("%3.2f"),((double)dwValue)/100);
			break;
		}
		case 3:
		{
			sValue.Format(_T("%4.3d"),((double)dwValue)/1000);
			break;
		}
		case 4:
		{
			sValue.Format(_T("%5.4d"),((double)dwValue)/10000);
			break;
		}
		case 5:
		{
			sValue.Format(_T("%6.5d"),((double)dwValue)/100000);
			break;
		}
	}
	m_Amount.SetWindowText(sValue);
}

void CBillAcceptorDlg::OnBillStatus(WPARAM wParam, LPARAM lParam)
//===============================================================
{
	TRACE(_T("Message: %d\r\n"),wParam);
	switch (wParam)
	{
		case SS_BILL_READY:
		{
			if (!BillInfo(&m_BillInfo))
				break;
			m_LastStatus.SetWindowText(_T("Ready."));
			break;
		}
		case SS_BILL_STATUS:
		{
			BILL_STATUS Status;
			if (!BillStatus(&Status))
				break;
			switch (Status.dwBillStatus)
			{
				case 0x06:
				{
					m_LastStatus.SetWindowText(_T("Just reset."));
					break;
				}
				case 0x08:
				{
					m_LastStatus.SetWindowText(_T("Cashbox out of position."));
					break;
				}
				case 0x09:
				{
					m_LastStatus.SetWindowText(_T("Unit disabled."));
					break;
				}
				case 0x0A:
				{
					m_LastStatus.SetWindowText(_T("Invalid escrow request."));
					break;
				}
				case 0x0B:
				{
					m_LastStatus.SetWindowText(_T("Bill rejected."));
					break;
				}
			}
			break;
		}
		case SS_BILL_ESCROW:
		{
			BILL_STATUS Status;
			if (!BillStatus(&Status))
				break;
			DisplayAmount(m_BillInfo.dwBillScalingFactor*m_BillInfo.BillTypeCredit[Status.dwBillType]);
			switch (Status.dwBillRouting)
			{
				case 0:
				{
					m_LastStatus.SetWindowText(_T("Bill stacked."));
					DisplayAmount(0);
					break;
				}
				case 1:
				{
					m_LastStatus.SetWindowText(_T("Bill in escrow position."));
					break;
				}
				case 2:
				case 4:
				{
					m_LastStatus.SetWindowText(_T("Bill returned."));
					DisplayAmount(0);
					break;
				}
			}
		}
	}
}
